import React, { useCallback } from 'react';
import {
    Form_ListingFragment,
    useUpsertFormListingMutation,
} from 'gql/generated/react';
import { useSessionContext } from 'supertokens-auth-react/recipe/session';
import { UseFormGetValues } from 'react-hook-form';

export const useFormUpsertListing = (
    getFormValues: UseFormGetValues<Form_ListingFragment>
) => {
    const [upsertFormListing] = useUpsertFormListingMutation();
    const { userId } = useSessionContext();

    const onSubmit = useCallback(async () => {
        await upsertFormListing({
            variables: {
                input: {
                    title: getFormValues('title'),
                    description: getFormValues('description'),
                    price: getFormValues('price'),
                    currency: getFormValues('currency'),
                    creator_id: userId,
                },
            },
        });
        // TODO redirect to listing page
    }, [upsertFormListing, getFormValues, userId]);

    return { onSubmit };
};
